#include "../Scoreboard/ScoreBoard.h"
#include <fstream>
#include <string>

namespace _SCOREBOARD
{
Scoreboard::Scoreboard()
{
	hasScore = false;
	scoreIndex = 0;
	boardIndex = 0;
	std::ifstream getTable("score.tbl");
	int s;
	char tmpBuff[10];
	getTable >> totalScores;

	for(int i = 0; i < totalScores; i++)
	{
		getTable >> boardEntry[i];
		getTable >> s;
		boardEntry[i].append(" ");
		boardEntry[i].append(_itoa(s, tmpBuff, 10));
	}
	getTable.close();
}

void Scoreboard::addToName(char letter)
{
	if(scoreIndex < 3)
	{
		boardEntry[boardIndex].replace(scoreIndex, 1, std::string(&letter));
		scoreIndex++;

		if(scoreIndex == 3)
		{
			std::ofstream setTable("score.tbl");
			setTable << totalScores << std::endl;
			for(int i = 0; i < totalScores; i++)
			{
				setTable << boardEntry[i] << std::endl;
			}
			setTable.close();
			scoreIndex++;
		}
	}
}

bool Scoreboard::gotNewScore(void)
{	return hasScore;	}

int Scoreboard::getTotal(void)
{  return totalScores;  }

std::string	Scoreboard::getEntry(int index)
{  return boardEntry[index];  }

void Scoreboard::newScore(int score)
{
	int scores[10];
	char tmpBuff[10];
	std::string tmpScore;
	std::ofstream setTable("score.tbl");

	for(int i = 0; i< totalScores; i++)
	{
		tmpScore = boardEntry[i].substr(4, boardEntry[i].length()-4);
		scores[i] = strtol(tmpScore.c_str(), NULL, 10);
	}

	for(int i = 0; i < totalScores; i++)
	{
		if(score >= scores[i])
		{
			hasScore = true;
			scoreIndex = 0;
			boardIndex = i;
			int insert, curMarker;
			if(totalScores == 10)
			{
				insert = 9;
				curMarker = 8;
			}
			else
			{
				insert = totalScores;
				curMarker = insert-1;
			}
			while(insert > i)
			{
				boardEntry[insert] = boardEntry[curMarker];
				insert--;
				curMarker--;
			}
			boardEntry[i] = std::string("--- ");
			boardEntry[i].append(_itoa(score, tmpBuff, 10));
			if(totalScores < 10)
				totalScores++;
			break;
		}
		if(i == totalScores-1 && totalScores < 10)
		{
			boardEntry[totalScores] = std::string("NUL ");
			boardEntry[totalScores].append(_itoa(score, tmpBuff, 10));
			totalScores++;
			break;
		}
	}
	if(totalScores == 0)
	{
		boardEntry[totalScores] = std::string("NUL ");
		boardEntry[totalScores].append(_itoa(score, tmpBuff, 10));
		totalScores++;
	}
	
	setTable << totalScores << std::endl;
	for(int i = 0; i < totalScores; i++)
	{
		setTable << boardEntry[i] << std::endl;
	}
	setTable.close();
}

}